/*	Serpent Strong Encryption Plugin for Back Orifice 2000
	Copyright (C) 1999, Daniel Roethlisberger

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	The author of this program may be contacted at admin@roe.ch.
*/

#ifndef MYSERPENT_H
#define MYSERPENT_H

#include <windows.h>
#include "serpent.h"

typedef struct {
	u4byte SerpentKey[140];					// internal key schedule
	u4byte SerpentUserKey[8];				// 256 bit user key
	char svSerpentKey[256];					// up to 255 char key string
	BYTE SerpentInitVect[SERPENT_BLOCK_SIZE];	// initialisation vector
} SERPENT_CTX;

int __cdecl Serpent_Insert(void);
int __cdecl Serpent_Remove(void);
char * __cdecl Serpent_Query(void);
void * __cdecl Serpent_Startup(void);
int __cdecl Serpent_Shutdown(void *pInternal);
int __cdecl Serpent_SetKey(void *pInternal, char *pKey);
char * __cdecl Serpent_GetKey(void *pInternal);
BYTE * __cdecl Serpent_Encrypt(void *pInternal, BYTE *pBuffer, int nBufLen, int *pnOutBufLen);
BYTE * __cdecl Serpent_Decrypt(void *pInternal, BYTE *pBuffer, int nBufLen, int *pnOutBufLen);
int __cdecl Serpent_CreateNewKeys(void *pInternal);
void __cdecl Serpent_Free(void *pInternal, BYTE *pBuffer);

#endif // MYSERPENT_H